/*
 * z2-Environment
 * 
 * Copyright(c) ZFabrik Software GmbH & Co. KG
 * 
 * contact@zfabrik.de
 * 
 * http://www.z2-environment.eu
 */
package com.zfabrik.components.java;

import java.net.URL;
import java.net.URLClassLoader;
import java.net.URLStreamHandlerFactory;
import java.util.Collection;

/**
 * Just combining {@link IJavaComponentClassLoader} and {@link URLClassLoader}. {@link IJavaComponentClassLoader} may be deprecated in the future.
 * @author hb
 *
 */
public abstract class JavaComponentClassLoader extends URLClassLoader implements IJavaComponentClassLoader {

	public JavaComponentClassLoader(URL[] urls, ClassLoader parent,	URLStreamHandlerFactory factory) {super(urls, parent, factory);}

	public JavaComponentClassLoader(URL[] urls, ClassLoader parent) {super(urls, parent);}

	public JavaComponentClassLoader(URL[] urls) {super(urls);}
	
	/**
	 * Return all packages that are found on the local 
	 * classpath of this loader. This is not including delegation.
	 * Package names are normalized to be "/"-separated and have no
	 * leading or trailing "/"
	 */
	public abstract Collection<String> getClassPathPackages();

}
